//-----------　以下のコードは必要のあるユーザのみ記述する --------------

// もしMain()の開始前に実行しておきたいコードが別にある場合は以下に記述．
// このルーチンの出力はログファイルに記録されません．
void preMain() {
}

// もしMain()終了後に実行しておきたいコードが別にある場合は以下に記述．
// このルーチンの出力はログファイルに記録されません．
void postMain() {
}

// ユーザ独自のmousePressed()
void userMousePressed() {
}
// ユーザ独自のmouseRelased()
void userMouseReleased() {
}
// ユーザ独自のmouseDragged()
void userMouseDragged() {
}
// ユーザ独自のmouseMoved()
void userMouseMoved() {
}
// ユーザ独自のmouseClicked()
void userMouseClicked() {
  if (mouseButton == RIGHT) {
    int target = crow.detectActiveView(mouseX, mouseY);
    if (target < 0) return;
    targetView = target;
  } else if (mouseButton == LEFT) {
    int mx, my;
    mx = mouseX; my = height - mouseY;
    crow.lastView();
    crow.cv.stroke(#800000);
    if (clicked == false) crow.cv.moveTo(mx, my);
      else                crow.cv.dashedLineTo(mx, my, 5.0);
    clicked = true;
    crow.cv.fill(#202020);
    crow.cv.stroke(#000000);
    crow.cv.rectMode(CENTER);
    crow.cv.rect(mx, my, 10, 10);
  }
}
// ユーザ独自のkeyPressed()
void userKeyPressed() {
  switch (key) {
    case '1' : crow.toggleViewVisible(0); break;
    case '2' : crow.toggleViewVisible(1); break;
    case '3' : crow.toggleViewVisible(2); break;
    case '4' : crow.toggleViewVisible(3); break;
    case 't' :
    case 'T' : crow.viewMoveToTop(targetView); break;
    case 'b' :
    case 'B' : crow.viewMoveToBottom(targetView); break;
    case 'c' :
    case 'C' : crow.lastView(); crow.cv.clrView(); clicked = false; break;
  }
  switch (keyCode) {
    case LEFT  : crow.moveViewRel(targetView, -2,  0); break;
    case RIGHT : crow.moveViewRel(targetView,  2,  0); break;
    case UP    : crow.moveViewRel(targetView,  0, -2); break;
    case DOWN  : crow.moveViewRel(targetView,  0,  2); break;
  }
}
// ユーザ独自のkeyRleased()
void userKeyReleased() {
}
// ユーザ独自のkeyTyped()
void userKyeTyped() {
  if ((key == 'Q') || (key == 'q')) crow.stop();
}

// もしMain()終了後に通常のProcessingのようにエンドレスに処理を続ける場合は
// Setup()にcrowbar.nonStop()を記述すると共に，以下にコードを記述．
// ユーザ独自のdraw()
int i = 0;
void userDraw() {
//background(_BGCOLOR);
  int mx, my, i;
  mx = mouseX - 20;
  my = height - mouseY - 20;

//crow.clrAllView();
  // 回転
  crow.view("RightUpper");
  crow.cv.worldCenter(mx, my);
  crow.cv.viewRotateRel(PI / 360);
  crow.cv.viewPivotCenter();
/*
  crow.getView("RightUpper").rotateAngleRel(PI / 360);
  crow.getView("RigutUpper").viewPivotCenter();
*/
  for (i = 0; i < 4; i++) {
    crow.view(i);
    if (i == targetView) crow.cv.frameColor(#ff0000);
      else               crow.cv.frameColor(#000000);
    crow.cv.clrView();
    crow.cv.stroke(#000000);
    crow.cv.fill(#ffffff);
    crow.cv.line(0, 0, 1000,    0);
    crow.cv.line(0, 0,    0, 1000);
    crow.cv.ellipse(0, 0, 20);
    switch (i) {
      case 1 :
        crow.cv.triangle(mx, my, 50.0, PI);
        crow.cv.viewTextColor(#ff0000);
        break;
      case 3 : 
        crow.cv.triangle(mx, my, 50.0);
        crow.cv.viewTextColor(#ffffff);
        break;
      default :
//        crow.cv.ellipse(mx, my, 50);
        crow.cv.quad(mx - 5, my + 5, mx -10, my - 10, mx + 12, my -12, mx + 8, my + 8);
        crow.cv.viewTextColor(#000000);
    }
    crow.cv.stroke(#404040);
    crow.cv.strokeWeight(3);
    crow.cv.lineTo(0, 0);
    crow.cv.strokeWeight(1);
    crow.cv.text("Mouse(" + str(mouseX) + "," + str(mouseY) + ")", 50, 50);
  }

  crow._clrscr();
  fill(#808000);
  stroke(#000000);
  ellipse(mouseX, mouseY, 50, 50);
  line(0, 0, mouseX, mouseY);
  crow._write(cx, cy, "Mouse(");
  crow._write(str(mouseX));
  crow._write(",");
  crow._write(str(mouseY));
  crow._write(")");
  crow._write(cx, cy + 1, "[1] [2] [3] [4]");
  crow._write(cx, cy + 2, "ビューポートの表示切り替え");
  crow._write(cx, cy + 3, "マウス右クリック：ビューポート選択");
  crow._write(cx, cy + 4, "マウス左クリック：マーク表示");
  crow._write(cx, cy + 5, "[C]: マーク表示画面の消去");
  crow._write(cx, cy + 6, "[T]: 最上面へ [B]: 最下面へ");
  crow._write(cx, cy + 7, "カーソルキー: ビューポート移動");
}

